/**
 * description
 *
 * @author eson
 *2022年6月09日-16:29:17
 */
package com.yuandian.dataflow.grpc;

import java.time.Duration;
import java.time.Instant;

import com.google.protobuf.Any;
import com.google.protobuf.InvalidProtocolBufferException;
import com.yuandian.dataflow.proto.CollectPacketsServerGrpc;
 

import com.yuandian.dataflow.proto.Base.Request;
import com.yuandian.dataflow.proto.Base.Response;
import com.yuandian.dataflow.proto.CollectPacketsServerGrpc.CollectPacketsServerImplBase;
import com.yuandian.dataflow.proto.CollectPacketsServerGrpc.CollectPacketsServerStub;

import com.yuandian.dataflow.proto.msgtype.ApmBaseDataFlowOuterClass.ApmBaseDataFlow;


import io.grpc.ManagedChannelBuilder;
import io.grpc.netty.shaded.io.netty.handler.codec.compression.CompressionOptions;
import io.grpc.stub.StreamObserver;
import lombok.extern.slf4j.Slf4j;

/**
 * description
 *
 * @author eson
 *2022年6月09日-16:29:17
 */
@Slf4j
public class CollectPackets extends CollectPacketsServerImplBase {

   
    public static void main(String[] args) throws InvalidProtocolBufferException {
        
    //     private final ManagedChannelBuilder<?> managedChannelBuilder;
    //     private final CollectPacketsServerStub blockingStub;

    // private final ManagedChannel channel;
    // public Client(String name, int port) {

    // }
    // public void shutdown() throws InterruptedException {
    //     channel.shutdown().awaitTermination(5, TimeUnit.SECONDS);
    // }
    // public  void sayHi(String name){
    //     MyThing.Request request = MyThing.Request.newBuilder().setName(name).build();
    //     MyThing.Response response = blockingStub.sayHi(request);
    //     System.out.println(response.getName());
    // }
    var managedChannelBuilder = ManagedChannelBuilder.forAddress("localhost", 50051);
    var channel = managedChannelBuilder.usePlaintext().build();
    var stub = CollectPacketsServerGrpc.newBlockingStub(channel);
    // stub.withCompression("snappy");
      
    var response =  stub.getPackets(Request.newBuilder().setVersion("0.1.0").build());
     
    while(true){
        var iter = response.next();
        Instant now = Instant.now();
        var i = 0;
        for(var p : iter.getPacketsList()) {
            if(p.is(ApmBaseDataFlow.class)) {
                var flow = p.unpack(ApmBaseDataFlow.class);
                i ++;
            } 
        }

        log.info("条数:{}, {}:ms",i,Duration.between(now, Instant.now()).toMillis());
    }
   
    }
}
